Redmine - Feature #588

Move timelog between projects
2008-01-25 09:43 - Michael Pirogov

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Time tracking Estimated time: 0.00 hour
Target version: 3.4.0
Description

It'll be nice to have an ability to move or delete your timelog entries between projects (as issue_move). For example
cause of mistake.

Related issues:

Related to Redmine - Patch #26534: Allow project bulk edit of time entries Closed
Has duplicate Redmine - Feature #22399: Edit project of time entries Closed
Has duplicate Redmine - Feature #25381: Allow project selection when editing ... Closed

Associated revisions

Revision 16450 - 2017-04-03 11:33 - Jean-Philippe Lang

Timelog move between projects (#588).

Patch by Marius BALTEANU.

History

#1 - 2008-02-07 19:05 - David Petersen

You can "move" a time entry by editing it and then changing the issue number, time really isn't linked to a project but a issue.

The ability to delete a time entry would be nice.

#2 - 2008-02-07 20:41 - Michael Pirogov

- File issue_move.png added

time really isn't linked to a project but a issue.
I think, it is. Try to change Issue number to another, which not belongs to the current project and you'll get an error. I'll attach a screenshot. You can
see, that error is displayed even if an Issue ID exists and received correctly.

P.S. "Allow cross-project issue relations" is enabled.

#3 - 2008-02-07 20:50 - Jean-Philippe Lang

Indeed, the time entry can not currently be moved to an issue of another project.
I think | could change this behaviour. What do you think ?

#4 - 2008-02-07 21:08 - Michael Pirogov

In our company we are spending less time to fill in a time entries. We just fill'em in one default 'stuff' project and then, near the end of the week and/or
month, sort them. For another example: you have to do a very high priority work and after that you got next one (urgent too). There is no time to fill in
all the forms to create a new issue. So you just made a 'timestamp' in 'stuff' (common, garbage, etc) project and at the end of a work day you'll create
an issue ticket with all the things inside. After that you have to create a relation with your time entry. Back in time :) It's reverse logic: 1. Time entry 2.
Issue. Something like that. Hope it's understandable. Sorry for my english, it's night up here now :)

#5 - 2008-02-07 21:34 - David Petersen
- File destroy.rhtml added

- File timelog_controller.rb.patch added
- File details.rhtml.patch added

- File edit.html.patch added

- File redmine.rb.patch added
- File en.yml.patch added

Here are the files to add the delete functionality.

destroy.rhtml - should go /app/views/timelog/destroy.rhtml
timelog_controller.rb.patch - patch file for /app/controllers/timelog_controller.rb
details.rhtml.patch - patch file for /app/views/timelog/details.rhtml
edit.rhtml.patch - patch file for /app/views/timelog/edit.rhtml

redmine.rb.patch - patch file for /lib/redmine.rb

en.yml.patch - patch file for /lang/en.yml

Think thats all the changes needed.

#6 - 2008-02-07 21:39 - Jean-Philippe Lang

Thanks. I'll have a look at all these files, even if a single diff would be easier to apply :-)

#7 - 2008-02-15 15:53 - David Petersen
Sorry about that, Still learning about the whole patch thing.

#8 - 2008-04-10 10:39 - Michael Pirogov

- Target version set to 0.7
up. It's really one of major things...

#9 - 2008-04-19 14:04 - Jean-Philippe Lang
- Target version deleted (0.7)

#10 - 2011-03-23 10:36 - Toshi MARUYAMA

- Category set to Time tracking

#11 - 2011-08-25 16:43 - Jens Wellmeyer

The problem with moving spent time from one project to another still exists. We use redmine to track our time spent with over 200 Projects and would
love to be able to transfer entries.
Any chance that this will be included in an upcoming version?

#12 - 2013-03-21 10:07 - Paco Alcaide

® In our company we would like this issue too.
* We use time entries very hardly, and for now to move time entries, first we move it to another issue brother to the first one an inside the project
(this is possible), and then we move the issue to another project or we make it daughter to another issue on the second project.

#13 - 2013-08-16 17:23 - Keven Marin

+1 for this feature.

#14 - 2014-02-24 06:53 - Anton Nepomnyaschih

It would be helpful to add more detailed error message, not only "Invalid issue", but for example "Timelog can't be moved between projects”.
#15 - 2014-04-02 14:35 - Adrien Simon
+1 for this feature from our side too :-)

If we can assist in anyway, drop me a note.

#16 - 2015-04-07 14:18 - Lydia Carley

+1 from our company, too. For an efficient time logging tool this feature must be available.

#17 - 2015-09-03 21:49 - Simon Deziel

Having this implemented would be really nice as the current workarounds are quite cumbersome.
#18 - 2016-01-05 13:01 - Paco Alcaide

e We have updated our Redmine from v. 2.2.2.0 to 3.2.0 the past December 16th 2015, and today | have found that this issue is solved, but |
could not say from which version, because our jump has been great.
#19 - 2016-02-03 14:20 - Toshi MARUYAMA

- Subject changed from Timelog move/delete to Timelog move/delete between projects
#20 - 2016-02-03 14:24 - Toshi MARUYAMA
Paco Alcaide wrote:
e We have updated our Redmine from v. 2.2.2.0 to 3.2.0 the past December 16th 2015, and today | have found that this issue is solved, but |

could not say from which version, because our jump has been great.

Redmine 3.2 still cannot move timelog without issue.
#21 - 2016-02-04 08:47 - Paco Alcaide
Toshi MARUYAMA wrote:
Paco Alcaide wrote:
e We have updated our Redmine from v. 2.2.2.0 to 3.2.0 the past December 16th 2015, and today | have found that this issue is solved,
but | could not say from which version, because our jump has been great.

Redmine 3.2 still cannot move timelog without issue.

If | understood good the issue, in Redmine we could not change the hours between proyects. | insist, we could not, because, due your comment, |
promise you that right now, | have repeated the test and | have changed the issues numbers in 2 timelog entries at the same time, inside my Redmine
v3.2, moving the hours to other issue, so to other proyect.

¢Maybe could be something about in the setup inside Redmine that let you do it?

#22 - 2016-02-04 10:22 - Toshi MARUYAMA

You can move time log if it links to issue.
But, you cannot if it does not link to issue.

#23 - 2016-12-29 23:34 - Marius BALTEANU

We're very interested too in this feature, but I'm not sure how it should work.

| see 2 possibilities:

1. Allow moving between projects only spent times without issue id. This means that if you want to move a spent time with issue id to another project,

first you need to unlink it from the issue and then change the project.

2. Allow moving all. This way seems a little bit more complex because there are multiple scenarios to take into consideration (clear issue when the
project is changed, validate issue id and the project on save, etc).

Which is the desired behaviour?

#24 - 2017-02-12 23:28 - Marius BALTEANU
- File change_timelog_project.patch added

The attached patch allows moving timelogs between projects. | chose the second solution from my previous note (the issue_id is removed on project
change event) because | think that is easier for the user.

Any feedback is welcomed. | really think that this feature is needed (we have a lot of cases per month where we need to change the timelog project) .
@Jean-Philippe Lang, the issue_id hidden_field_tag from timelog form
<% elsif params[:issue_id] %>
<%= hidden_field_tag 'issue_id', params[:issue_id] %>
has any purpose? I'm asking because the issue_id text_field is always displayed in the form.

#25 - 2017-03-03 20:21 - Marius BALTEANU
Any feedback on this patch? | really think that this feature is needed.

#26 - 2017-03-03 21:26 - Jean-Philippe Lang
- Assignee set to Jean-Philippe Lang
- Target version set to 3.4.0

#27 - 2017-04-03 11:37 - Jean-Philippe Lang
- Subject changed from Timelog move/delete between projects to Move timelog between projects
- Status changed from New to Closed

- Resolution set to Fixed

Patch committed, thanks Marius. I've merged the changes to the bulk edit form as it's not fully working, we should have a way to clear issues
(otherwise the update might fail) and the activity list should be updated when changing the project.

@Jean-Philippe Lang, the issue_id hidden_field_tag from timelog form has any purpose? I'm asking because the issue_id text_field is always

displayed in the form.

The :issue_id param is used to redirect with the proper params. The form contains a different parma: time_entry[:issue_id].

#28 - 2017-04-03 15:59 - Marius BALTEANU

Jean-Philippe Lang wrote:
Patch committed, thanks Marius. I've merged the changes to the bulk edit form as it's not fully working, we should have a way to clear issues
(otherwise the update might fail) and the activity list should be updated when changing the project.

Thanks for committing the patch. The changes for bulk edit shouldn't be in the patch from the beginning, they are just a quick solution for us internally.

I'll create a new issue when I've the changes ready for the core.

The :issue_id param is used to redirect with the proper params. The form contains a different parma: time_entry[:issue_id].

Ah, my bad, sorry for not seeing this.

#29 - 2017-04-03 17:18 - Go MAEDA
- Has duplicate Feature #22399: Edit project of time entries added

#30 - 2017-04-19 13:09 - Toshi MARUYAMA

- Has duplicate Feature #25381: Allow project selection when editing timelog entries added

#31 - 2017-08-06 15:10 - Marius BALTEANU
Marius BALTEANU wrote:
Jean-Philippe Lang wrote:
Patch committed, thanks Marius. I've merged the changes to the bulk edit form as it's not fully working, we should have a way to clear

issues (otherwise the update might fail) and the activity list should be updated when changing the project.

Thanks for committing the patch. The changes for bulk edit shouldn't be in the patch from the beginning, they are just a quick solution for us
internally. I'll create a new issue when I've the changes ready for the core.

The patch that implements the project bulk edit for time entries was added to #26534.

#32 - 2018-01-03 03:57 - Marius BALTEANU
- Related to Patch #26534: Allow project bulk edit of time entries added
